package cz.uhk.fim.smarttodo.common;

import cz.uhk.fim.smarttodo.domain.User;
import cz.uhk.fim.smarttodo.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.AccessDeniedException;
import org.springframework.security.core.Authentication;

import java.util.Locale;

public abstract class AppControllerAncestor {

    @Autowired
    protected UserRepository userRepository;

    @Autowired
    protected StCommonService stCommonService;

    protected User getUser(Authentication authentication, Locale locale) {
        User user = userRepository.findByUsername(authentication.getName());

        if (user == null) {
            final String message = stCommonService.format("app.accessDenied.userExist", locale);
            throw new AccessDeniedException(message);
        }

        return user;
    }
}
