package cz.uhk.fim.smarttodo.common.rs;

import cz.uhk.fim.smarttodo.common.StCommonService;
import cz.uhk.fim.smarttodo.common.validation.ValidationInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import javax.validation.ValidationException;

@ControllerAdvice
public class CommonControllerAdvice {

    private final StCommonService stCommonService;

    @Autowired
    public CommonControllerAdvice(StCommonService stCommonService) {
        this.stCommonService = stCommonService;
    }

    @ExceptionHandler(value = {ValidationException.class})
    @ResponseStatus(HttpStatus.BAD_REQUEST)
    public @ResponseBody
    ValidationInfo validationException(ValidationException ex) {
        return stCommonService.convertValidationException(ex);
    }
}
