package cz.uhk.fim.smarttodo.common.validation;

import javax.validation.ValidationException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.stream.Collectors;

public class StValidationException extends ValidationException {

    private Collection<ValidationMessage> messages = new ArrayList<>();

    public StValidationException(ValidationMessage... msgs) {
        if (msgs != null && msgs.length > 0) {
            messages = Arrays.asList(msgs);
        }
    }

    public StValidationException(Collection<ValidationMessage> messages) {
        this.messages = messages;
    }

    public StValidationException(String message) {
        messages.add(new ValidationMessage(message));
    }

    public StValidationException(String message, String propertyPath) {
        messages.add(new ValidationMessage(propertyPath, message));
    }


    public Collection<ValidationMessage> getMessages() {
        return messages;
    }

    @Override
    public String getMessage() {
        return String.join(", ", messages.stream().map(ValidationMessage::getMessage).collect(Collectors.toSet()));
    }
}
