package cz.uhk.fim.smarttodo.domain;

import cz.uhk.fim.smarttodo.dto.event.EventDto;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name = "\"EVENT\"")
public class Event {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer eventId;

    @Column(nullable = false)
    private String name;

    @Column(nullable = false)
    private Date onDate;

    @Column
    private String color;

    @ManyToOne
    @JoinColumn(name = "userId")
    private User user;

    public Integer getEventId() {
        return eventId;
    }

    public void setEventId(Integer eventId) {
        this.eventId = eventId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Date getOnDate() {
        return onDate;
    }

    public void setOnDate(Date onDate) {
        this.onDate = onDate;
    }

    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public EventDto mapToEventDto() {
        EventDto dto = new EventDto();
        dto.setEventId(this.eventId);
        dto.setName(this.name);
        dto.setColor(this.color);
        dto.setOnDate(this.onDate);

        return dto;
    }
}
