import store from "../store/index";
import Axios from "axios";
import i18n from "../i18n";

const instance = Axios.create({
  // baseURL: "http://localhost:8081/"
  baseURL: "https://smart-todo-app.herokuapp.com/"
});

instance.interceptors.request.use(
  function(config) {
    config.headers.common["Accept-Language"] = i18n.locale;

    if (store.getters.isLoggedIn)
      config.headers["Authorization"] = `Bearer ${store.state.login.token}`;
    return config;
  },
  function(error) {
    return Promise.reject(error);
  }
);

export default instance;
