import Vue from "vue";
import App from "./App.vue";
import router from "./router";
import store from "./store";
import vuetify from "./plugins/vuetify";
import i18n from "./i18n";
import VueClipboard from "vue-clipboard2";

import LoggedLayout from "./layouts/LoggedLayout";
import PublicLayout from "./layouts/PublicLayout";
import BasicLayout from "./layouts/BasicLayout";
import Axios from "axios";

Vue.component("logged-layout", LoggedLayout);
Vue.component("public-layout", PublicLayout);
Vue.component("basic-layout", BasicLayout);

Vue.use(VueClipboard);

// Axios.defaults.baseURL = "http://localhost:8081/";
Axios.defaults.baseURL = "https://smart-todo-app.herokuapp.com/";

Vue.config.productionTip = false;

store.dispatch("tryAutoLogin");

new Vue({
  store,
  router,
  vuetify,
  i18n,
  render: h => h(App)
}).$mount("#app");
